<ui:composition xmlns:rich="http://richfaces.org/rich"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:g="http://www.ihe.net/gazelle"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns="http://www.w3.org/1999/xhtml">
    <s:decorate template="/layout/panels/_panel_filter_criteria.xhtml"
                id="pfc_enc">
        <div class="row">
            <div class="col-md-4">
                <ui:include src="/filter/filter.xhtml">
                    <ui:param name="filterName" value="#{messages['gazelle.pam.PatientsFirstName']}"/>
                    <ui:param name="filterId" value="firstName"/>
                    <ui:param name="filter" value="#{automatonManager.encounterFilter.filter}"/>
                    <ui:param name="filterForm" value="globalForm"/>
                </ui:include>
            </div>
            <div class="col-md-4">
                <ui:include src="/filter/filter.xhtml">
                    <ui:param name="filterName" value="#{messages['gazelle.pam.PatientsLastName']}"/>
                    <ui:param name="filterId" value="lastName"/>
                    <ui:param name="filter" value="#{automatonManager.encounterFilter.filter}"/>
                    <ui:param name="filterForm" value="globalForm"/>
                </ui:include>
            </div>
            <div class="col-md-4">
                <ui:include src="/filter/filter.xhtml">
                    <ui:param name="filterName" value="#{messages['gazelle.pam.PatientsGender']}"/>
                    <ui:param name="filterId" value="gender"/>
                    <ui:param name="filter" value="#{automatonManager.encounterFilter.filter}"/>
                    <ui:param name="filterForm" value="globalForm"/>
                </ui:include>
            </div>
        </div>
        <div class="row">
            <div class="col-md-6">
                <ui:include src="/filter/filterDate.xhtml">
                    <ui:param name="filterName" value="#{messages['gazelle.pam.CreationDate']}"/>
                    <ui:param name="filterId" value="timestamp"/>
                    <ui:param name="filter" value="#{automatonManager.encounterFilter.filter}"/>
                    <ui:param name="filterForm" value="globalForm"/>
                </ui:include>
            </div>
            <div class="col-md-6">
                <f:subview id="username" rendered="#{identity.loggedIn}">
                    <ui:include src="/filter/filter.xhtml">
                        <ui:param name="filterName" value="#{messages['users.Username']}"/>
                        <ui:param name="filterId" value="creator"/>
                        <ui:param name="filter" value="#{automatonManager.encounterFilter.filter}"/>
                        <ui:param name="filterForm" value="globalForm"/>
                    </ui:include>
                </f:subview>
            </div>
        </div>
        <ui:define name="filter_buttons">
            <a4j:commandLink title="#{messages['gazelle.pam.RefreshList']}"
                             render="encountersList">
                <span class="gzl-icon-refresh"/>
            </a4j:commandLink>
            <a4j:commandLink title="#{messages['net.ihe.gazelle.simulator.hl7.ResetCriteria']}"
                             actionListener="#{automatonManager.encounterFilter.reset()}"
                             render="globalForm">
                <span class="gzl-icon-times-circle"/>
            </a4j:commandLink>
        </ui:define>
    </s:decorate>
    <rich:dataTable value="#{automatonManager.encounterFilter.encounters}"
                    var="enc" render="ds" id="encountersList"
                    rows="#{dataScrollerMemory.numberOfResultsPerPage}">
        <g:column>
            <f:facet name="header">#{messages['gazelle.simulator.pam.Patient']}</f:facet>
            <h:outputText value="#{enc.patient.firstName} #{enc.patient.lastName} (#{enc.patient.genderCode})"
                          style="font-weight: bold"/>
            <br/>
            <a4j:repeat value="#{enc.patient.patientIdentifiers}" var="pid">
                <h:outputText value="#{pid.fullPatientId}"/>
                <br/>
            </a4j:repeat>
        </g:column>
        <ui:include src="/iti31/abstractEncountersColumns.xhtml">
            <ui:param name="encounter" value="#{enc}"/>
        </ui:include>
        <g:column id="actionColumn">
            <f:facet name="header">#{messages['gazelle.simulator.pam.Action']}</f:facet>
            <h:outputLink value="#{enc.getPermanentLink()}"
                          target="_blank">
                <s:span styleClass="gzl-icon-search "/>
            </h:outputLink>
            <a4j:commandLink title="#{messages['gazelle.pam.SelectThisEncounter']}"
                             actionListener="#{automatonManager.selectEncounterForInsert(enc)}"
                             render="messageConfigurationPanel">
                <s:span styleClass="gzl-icon-medkit "/>
            </a4j:commandLink>
        </g:column>
        <f:facet name="footer">
            <ui:include src="/util/datatableFooter.xhtml">
                <ui:param name="dataScrollerId" value="ds"/>
                <ui:param name="dataTableId" value="encountersList"/>
            </ui:include>
        </f:facet>
    </rich:dataTable>
</ui:composition>